// @flow
import _ from 'lodash';
import {combineReducers} from 'redux';
import rest from './rest';

export default (sources: Array<{
	baseURL: string,

	/* eslint-disable max-len */
	entity: 'campaigns' | 'cases' | 'contacts' | 'companies' | 'documents' | 'leads' | 'listings' | 'opportunities' | 'properties' | 'transactions',

	/* eslint-enable max-len */
	key: string,
}>) => combineReducers(_.reduce(sources, (reducers, source) => ({
	...reducers,

	[source.key]: (state={data: [], loading: false}, action) => {
		let

			/* eslint-disable sort-vars */
			restSource = rest(source),
			newState = restSource.reducers[source.key](state, action);

		/* eslint-enable sort-vars */
		if(action.type === restSource.events[source.key].actionSuccess)
			return {
				...newState,
				lastResponse: action.origData,
			};

		return newState;
	},
}), {}));
