module.exports = {
	babelrc       : false,
	cacheDirectory: true,

	presets: [
		require.resolve('babel-preset-env'),
		require.resolve('babel-preset-react')
	],

	plugins: [
		require.resolve('babel-plugin-transform-flow-strip-types'),
		require.resolve('babel-plugin-transform-function-bind'),
		require.resolve('babel-plugin-transform-class-properties'),
		require.resolve('babel-plugin-transform-object-rest-spread'),
		require.resolve('babel-plugin-transform-export-extensions'),
		require.resolve('babel-plugin-transform-regenerator'),
	],

	env: {
		production: {
			plugins: [
				require.resolve('babel-plugin-transform-react-remove-prop-types'),

				// Speed up React plugins
				// WARN: Enable this after complete testing. Eg. Opportunities doesn't work with this
				// require.resolve('babel-plugin-transform-react-constant-elements'),
				// require.resolve('babel-plugin-transform-react-inline-elements')
			]
		},

		development: {
			plugins: [
				[require.resolve('babel-plugin-flow-runtime'), {'assert': true, 'annotate': true}],
				require.resolve('babel-plugin-transform-react-jsx-source'),
				require.resolve('babel-plugin-transform-react-jsx-self')
			]
		},

		test: {
			plugins: ['transform-es2015-modules-commonjs']
		}
	}
};
