const
	isProduction = process.env.NODE_ENV === 'production',
	path = require('path'),
	webpack = require('webpack');

module.exports = {
	cache  : true,
	context: path.resolve(__dirname, '..'),
	devtool: isProduction ? false : 'eval',
	entry  : './FetchListAPI/index',

	module: {
		loaders: [
			{
				exclude: /node_modules/,
				loader : 'babel-loader',
				query  : require('./babel'),
				test   : /\.js$/,
			},
		],

		noParse: /\.min\.js/,
	},

	output: {
		filename     : 'index.min.js',
		libraryTarget: 'commonjs2',
		path         : path.join(__dirname, '..', 'build'),
		pathinfo     : !isProduction,
		publicPath   : '/',
	},

	performance: {hints: false},

	plugins: [
		new webpack.optimize.OccurrenceOrderPlugin(),
		new webpack.optimize.UglifyJsPlugin({compress: {screw_ie8: true, warnings: false}}),

		new webpack.DefinePlugin({
			__DEV__      : !isProduction,
			'process.env': {NODE_ENV: JSON.stringify(isProduction ? 'production' : 'development')},
		}),
	].filter(i => !!i),

	resolve: {
		extensions: ['.json', '.js'],

		modules: [
			path.resolve(__dirname, '..', 'FetchListAPI'),
			path.resolve(__dirname, '..', 'node_modules'),
		],
	},

	stats : {colors: true},
	target: 'web',
};
